#tag Class
Protected Class TRDataSource
Inherits NSTableDataSourceMBS
	#tag Event
		Function numberOfRowsInTableView() As integer
		  if mSelectedRecords <> nil then
		    return mSelectedRecords.RecordCount
		  end if
		End Function
	#tag EndEvent

	#tag Event
		Function objectValue(column as NSTableColumnMBS, row as integer) As variant
		  if column <> nil and IdColumn <> nil   then 
		    dim val as Variant = TRColumn(column).Value(IdColumn.ids(row))
		    if val <> nil then return val.StringValue
		  end if
		  
		End Function
	#tag EndEvent


	#tag Method, Flags = &h0
		Sub Constructor(db as SQLiteDatabase)
		  mDB = db
		  mSelectedRecords = db.SQLSelect("Select * from Customers")
		End Sub
	#tag EndMethod


	#tag Property, Flags = &h0
		Columns() As TRColumn
	#tag EndProperty

	#tag Property, Flags = &h0
		IdColumn As TRColumn
	#tag EndProperty

	#tag Property, Flags = &h21
		Private mDB As SQLiteDatabase
	#tag EndProperty

	#tag Property, Flags = &h21
		Private mSelectedRecords As RecordSet
	#tag EndProperty

	#tag ComputedProperty, Flags = &h0
		#tag Getter
			Get
			  return mSelectedRecords
			End Get
		#tag EndGetter
		#tag Setter
			Set
			  mSelectedRecords = value
			End Set
		#tag EndSetter
		SelectedRecords As RecordSet
	#tag EndComputedProperty


	#tag ViewBehavior
		#tag ViewProperty
			Name="Index"
			Visible=true
			Group="ID"
			Type="Integer"
		#tag EndViewProperty
		#tag ViewProperty
			Name="Left"
			Visible=true
			Group="Position"
			Type="Integer"
		#tag EndViewProperty
		#tag ViewProperty
			Name="Name"
			Visible=true
			Group="ID"
			Type="String"
		#tag EndViewProperty
		#tag ViewProperty
			Name="Super"
			Visible=true
			Group="ID"
			Type="String"
		#tag EndViewProperty
		#tag ViewProperty
			Name="Top"
			Visible=true
			Group="Position"
			Type="Integer"
		#tag EndViewProperty
	#tag EndViewBehavior
End Class
#tag EndClass
